/*
    libtree : C++ lib that helps to work with tree-like data structures
    Copyright (C) 2019-2021 Alexey Appolonov

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef     ltree_push_backH
#define     ltree_push_backH

namespace tree{

//-----------------------------------------------------------------------------
// Add an element to a vector while using a memory reservation

template<typename A, typename B> void PushBack(A &dest, const B &new_element,
        int mem_step=1, const int mem_step_lim=-1){

    if((dest.size() + 1) > dest.capacity()){
        if(mem_step_lim > 0 && mem_step > mem_step_lim){
            mem_step = mem_step_lim;
            }
        dest.reserve(dest.capacity() + mem_step);
        }

    dest.push_back(new_element);
    }

//-----------------------------------------------------------------------------

} // namespace tree

#endif
